#from fastapi import FastAPI, HTTPException, Request
#from fastapi.responses import RedirectResponse, JSONResponse
#from fastapi.middleware.cors import CORSMiddleware
import requests
from motor.motor_asyncio import AsyncIOMotorClient
from datetime import datetime, timedelta
#from fastapi.responses import JSONResponse
from html.parser import HTMLParser
from pathlib import Path

import json

class SimpleHTMLParser(HTMLParser):
    """
    Parse and clean HTML content into plain text with proper formatting.
    """
    def __init__(self):
        super().__init__()
        self.text_parts = []

    def handle_data(self, data):
        # Append plain text data
        self.text_parts.append(data)

    def handle_starttag(self, tag, attrs):
        # Add new lines for specific tags
        if tag in ["p", "br", "div"]:
            self.text_parts.append("\n")

    def get_clean_text(self):
        # Combine all parts and remove excess whitespace
        return "".join(self.text_parts).strip()
        


# HubSpot App Credentials (Directly Declared)
CLIENT_ID = "bd54c59c-1b7a-4a17-8f58-af9bd89b1037"
CLIENT_SECRET = "da1a21fb-1147-428a-81a0-e9692ce6db41"
REDIRECT_URI = "https://5e0c-2a0a-ef40-1145-2801-c562-2c37-3595-1731.ngrok-free.app/oauth-callback"
FRONT_BASE_URL = "http://localhost:3000"
HUBSPOT_AUTH_URL = f"https://app.hubspot.com/oauth/authorize?client_id={CLIENT_ID}&redirect_uri={REDIRECT_URI}&scope=contacts"  #this is not needed here, as we r doing this endpoint n call via Softr
HUBSPOT_TOKEN_URL = "https://api.hubapi.com/oauth/v1/token"
HUBSPOT_IDENTITY_URL = "https://api.hubapi.com/oauth/v1/access-tokens"
MONGO_URI = "mongodb+srv://devalbhamare1:JgL8mxjRiMzGlJri@cluster0.2ieou.mongodb.net/?retryWrites=true&w=majority&appName=Cluster0"

HUBSPOT_SEARCH_CONTACT_URL = "https://api.hubapi.com/crm/v3/objects/contacts/search"

HUBSPOT_NOTES_URL = "https://api.hubapi.com/crm/v3/objects/notes"
HUBSPOT_NOTE_DETAILS_URL = "https://api.hubapi.com/crm/v3/objects/notes"


client = AsyncIOMotorClient(MONGO_URI)
database = client["spool"]
customers_collection = database['HBUsers']
notes_collection = database["Notes"]


# Temporary in-memory storage for sessions (replace with DB in production)
user_sessions = {}

#below GET is not needed here, as we r doing this endpoint n call via Softr, bt still keeping it

async def get_user(email: str):
    """
    Fetch user details by email from MongoDB.
    """    
    try:
        if not email:
            raise ValueError("Missing required field: email")

        # Query MongoDB to find the user by email        
        user = await customers_collection.find_one({"user_email": email}, {"_id": 0})  # Exclude MongoDB "_id" field

        if not user:
            return {"error": "User not found"}

        #print(user)  # Debugging purpose
        return user  # Returns the user JSON object directly

    except Exception as e:
        print(f"Error: {str(e)}")
        return {"error": str(e)}
      
async def refresh_token(refresh_token: str):
    """
    Refresh the HubSpot access token using the refresh token.
    """
    try:
        if not refresh_token:
            raise ValueError("Missing required field: refresh_token")

        headers = {"Content-Type": "application/x-www-form-urlencoded"}
        payload = {
            "grant_type": "refresh_token",
            "client_id": "bd54c59c-1b7a-4a17-8f58-af9bd89b1037",
            "client_secret": "da1a21fb-1147-428a-81a0-e9692ce6db41",
            "refresh_token": refresh_token,
        }

        response = requests.post(HUBSPOT_TOKEN_URL, headers=headers, data=payload)

        if response.status_code != 200:
            return {"error": response.json()}

        return response.json()  # Returns the new access token JSON

    except Exception as e:
        print(f"Error: {str(e)}")
        return {"error": str(e)}
      
  
async def get_contact_deals(data: dict):
    """
    Retrieve deals associated with a specific contact and include notes for each deal.
    """
    output_file = Path("sample.txt")
    dealstage = ""
    notes = []
    count = 0
    with open(output_file, "w", encoding="utf-8") as file:
        try:
            #data = await request.json()
            access_token = data.get("access_token")
            #contact_id = data.get("contact_id")  # this is spool customer's prosepct's ID
            customer_email = data.get("customer_email")
            prospect_email = data.get("prospect_email")
            

            if not access_token:
                raise Exception(status_code=400, detail="Missing required fields: access_token or contact_id")

            headers = {"Authorization": f"Bearer {access_token}"}
            
            ### Step 1:  we get all deals for our customer
            deals_association_url = f"https://api.hubapi.com/crm/v3/objects/deals?limit=100"
            response = requests.get(deals_association_url, headers=headers)
             
            if response.status_code != 200:
                raise Exception(status_code=response.status_code, detail=response.json())
            associated_deals = response.json().get("results", [])
            if not associated_deals:
                return {"notes": []}  # No associated deals found
            deals = []
            note_contents = []
            html_parser = SimpleHTMLParser()  # Create an instance of the parser
            # Step 2: Fetch detailed deal information baed on deal ID, 
            #to get deal stage, pipeline etc
            for deal in associated_deals:
                count+= 1
                deal_id = deal.get("id")

                # Fetch deal details
                deal_details_url = f"https://api.hubapi.com/crm/v3/objects/deals/{deal_id}?properties=dealname,amount,pipeline,dealstage,hs_lastmodifieddate"
                deal_response = requests.get(deal_details_url, headers=headers)

                if deal_response.status_code == 200:
                    deal_data = deal_response.json()
                    deal_properties = deal_data.get("properties", {})
                    
                    #print("Deal:", deal_data)
                    
                    # get deal pipeline
                    pipline_id=deal_properties.get("pipeline")
                    stage_id = deal_properties.get("dealstage")
                    dealstage = deal_properties.get("dealstage")
                    Dname = deal_properties.get("dealname")
                    #print("Deal Name: ", deal_properties.get("dealname"))
                    #print("pipeline_id ", pipline_id)
                    #print("stage_id ", stage_id)
                    
                    print(f"********* Deal Name: {Dname}, Count: {count}")
                    deal_pipeline_url = f"https://api.hubapi.com/crm/v3/pipelines/deals/{pipline_id}"
                    response = requests.get(deal_pipeline_url, headers=headers)
                    if response.status_code == 200:
                        pipeline_data = response.json()
                        #print("Pipeline: ", pipeline_data)
                        stages = pipeline_data.get("stages", [])
                        for stage in stages:
                            if stage["id"] == stage_id:
                                dealstage = stage["label"]
                                print("Deal Stage is: ", dealstage ) 

                    # Fetch notes associated with the deal, to get Note IDs
                    deal_notes_url = f"https://api.hubapi.com/crm/v3/objects/deals/{deal_id}/associations/notes"
                    notes_response = requests.get(deal_notes_url, headers=headers)
                    #print("Notes: ", notes_response)
                    
                    if notes_response.status_code == 200:
                        notes_data = notes_response.json().get("results", [])
                        
                        for note in notes_data:
                            note_id = note.get("id")
                            print("Note: ", note_id)
                            #Now get note details
                            note_details_response = requests.get(f"{HUBSPOT_NOTES_URL}/{note_id}?properties=hs_note_body", headers=headers)
                            if note_details_response.status_code == 200:
                                note_data = note_details_response.json()
                                properties = note_data.get("properties", {})
                                content_html = properties.get("hs_note_body", "No content found")
                                
                                html_parser.text_parts = []  # Reset the parser state
                                html_parser.feed(content_html)  # Parse the HTML
                                clean_content = html_parser.get_clean_text()  # Extract plain text
                                
                                # Prepare note details
                                created_at = properties.get("hs_createdate", "Unknown")
                                last_modified = properties.get("hs_lastmodifieddate", "Unknown")
                                title = properties.get("hs_note_title", "")
                                #here prospet email is commented as we r getting all notes
                                #for customer_email, so oonly deal name can give info abt prospect here
                                note_document = {
                                    "note_id": note_id,
                                    "content": clean_content,
                                    "customer_email": customer_email,
                                    #"prospect_email": prospect_email,
                                    "deal_id": deal_id,
                                    "dealname": deal_properties.get("dealname"),
                                    "amount": deal_properties.get("amount"),
                                    "pipeline": deal_properties.get("pipeline"),
                                    "dealstage": dealstage,
                                    "last_modified": deal_properties.get("hs_lastmodifieddate"),
                                }
                                file.write(json.dumps(note_document, indent=4))  # Serialize as JSON with indentation
                                file.write("\n\n")  # Separate each note with two new lines
                                notes.append(note_document)
                                    
                                if(deal_properties.get("dealname").lower() in prospect_email.lower()):
                                    print("*** This is a relevant deal ***********************")
                                    # add prospect_email only if it's found in deal name
                                    #so when you need all deals for given prospect email this will be returned
                                    note_document["prospect_email"] = prospect_email
                                    
                                # here not, how we are insterting all deals in the DB as of now
                                # Again, there will be no prospect_email for non matched deals
                                await notes_collection.update_one(
                                    {"note_id": note_id},  # Filter to check for existing `note_id`
                                    {"$set": note_document},  # Update or set the document fields
                                    upsert=True  # Insert if no document with the `note_id` exists
                                )

                    # Add deal with notes to the result
                    deals.append({
                        "deal_id": deal_id,
                        "dealname": deal_properties.get("dealname"),
                        "amount": deal_properties.get("amount"),
                        "pipeline": deal_properties.get("pipeline"),
                        "dealstage": dealstage,
                        "last_modified": deal_properties.get("hs_lastmodifieddate"),
                        "notes": notes,
                    })
                    
                    # this return value is not being used as of now
                    for note in notes:
                        # Append to response
                        note_contents.append({
                            "id": note.get("note_id"),
                            "content": note.get("content"),
                        })
                    
            return {"notes": note_contents}

        except Exception as e:
            print(str(e))
            raise Exception(status_code=500, detail=f"Internal server error: {str(e)}")
        

async def get_notes(data: dict):
    """
    Retrieve all notes from MongoDB based on customer_email and prospect_email.
    """
    try:
        # Parse request data
        #data = await request.json()
        customer_email = data.get("customer_email")
        prospect_email = data.get("prospect_email")
            
        if not customer_email or not prospect_email:
            raise Exception(
                status_code=400, detail="Missing required fields: customer_email or prospect_email"
            )
        # Step 1: Get user details
        user = await get_user(customer_email)

        if not user:
            print("User not found....", customer_email)
            raise ValueError("User not found.")

        access_token = user.get("access_token")
        expires_at = str(user.get("expires_at"))
        refresh_token_value = user.get("refresh_token")

        # Step 2: Check if token is expired, refresh if needed
        if is_token_expired(expires_at):
            print("Token expired, getting new one...")
            data_token = await refresh_token(refresh_token_value)
            access_token = data_token.get("access_token")
            print(access_token)
        
        print("Got tokens, trying to get deals now...")
        #step 3 Update ALL deals n notes
        await get_contact_deals({"access_token": access_token, "customer_email": customer_email, "prospect_email": prospect_email})

        # Query MongoDB for matching notes
        query = {"customer_email": customer_email, "prospect_email": prospect_email}
        notes_cursor = notes_collection.find(query)

        # Retrieve all notes
        notes = []
        async for note in notes_cursor:
            notes.append({
                "note_id": note.get("note_id"),
                "content": note.get("content", "No content"),
                "customer_email": note.get("customer_email"),
                "prospect_email": note.get("prospect_email"),
                "deal_id": note.get("deal_id"),
                "dealname": note.get("dealname"),
                "amount": note.get("amount", "0"),
                "pipeline": note.get("pipeline"),
                "dealstage": note.get("dealstage"),
                "last_modified": note.get("last_modified"),
            })

        if not notes:
            return {"notes": [f"No notes found for customer_email: {customer_email} and prospect_email: {prospect_email}"]}

        return {"notes": notes}

    except Exception as e:
        raise Exception(status_code=500, detail=f"Internal server error: {str(e)}")


from datetime import datetime

def is_token_expired(expires_at):
    """
    Check if the access token is expired.
    """
    try:
        expiry_time = datetime.fromisoformat(expires_at)
        return datetime.utcnow() > expiry_time
    except Exception as e:
        print(f"Error checking token expiry: {str(e)}")
        return True  # Assume expired if error

import asyncio
if __name__ == "__main__":
    test_data = {
        "customer_email": "vaios@theupsetpartners.com",
        "prospect_email": "panos@merlus.ai"
    }
    
    # Run the async function properly
    result = asyncio.run(get_notes(test_data))
    print(result)